"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The CustomerAddress model module.
 * @module model/CustomerAddress
 * @version 7.9.0
 */
var CustomerAddress = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>CustomerAddress</code>.
   * @alias module:model/CustomerAddress
   */
  function CustomerAddress() {
    _classCallCheck(this, CustomerAddress);
    CustomerAddress.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(CustomerAddress, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>CustomerAddress</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/CustomerAddress} obj Optional instance to populate.
     * @return {module:model/CustomerAddress} The populated <code>CustomerAddress</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new CustomerAddress();
        if (data.hasOwnProperty('type')) {
          obj['type'] = _ApiClient["default"].convertToType(data['type'], 'String');
        }
        if (data.hasOwnProperty('address_1')) {
          obj['address_1'] = _ApiClient["default"].convertToType(data['address_1'], 'String');
        }
        if (data.hasOwnProperty('address_2')) {
          obj['address_2'] = _ApiClient["default"].convertToType(data['address_2'], 'String');
        }
        if (data.hasOwnProperty('locality')) {
          obj['locality'] = _ApiClient["default"].convertToType(data['locality'], 'String');
        }
        if (data.hasOwnProperty('region')) {
          obj['region'] = _ApiClient["default"].convertToType(data['region'], 'String');
        }
        if (data.hasOwnProperty('country')) {
          obj['country'] = _ApiClient["default"].convertToType(data['country'], 'String');
        }
        if (data.hasOwnProperty('postal_code')) {
          obj['postal_code'] = _ApiClient["default"].convertToType(data['postal_code'], 'String');
        }
      }
      return obj;
    }
  }]);
  return CustomerAddress;
}();
/**
 * The type of the address.
 * @member {String} type
 */
CustomerAddress.prototype['type'] = undefined;

/**
 * The street number and name of the address.
 * @member {String} address_1
 */
CustomerAddress.prototype['address_1'] = undefined;

/**
 * Additional address line for unit number, P.O. Box, etc.
 * @member {String} address_2
 */
CustomerAddress.prototype['address_2'] = undefined;

/**
 * City, town, or locality name the address is located.
 * @member {String} locality
 */
CustomerAddress.prototype['locality'] = undefined;

/**
 * State, province, or region of the address.
 * @member {String} region
 */
CustomerAddress.prototype['region'] = undefined;

/**
 * ISO 3166-1 alpha-2 country code (e.g., \"US\", \"CA\", \"NZ\")
 * @member {String} country
 */
CustomerAddress.prototype['country'] = undefined;

/**
 * Postal or Zip code of the address.
 * @member {String} postal_code
 */
CustomerAddress.prototype['postal_code'] = undefined;
var _default = CustomerAddress;
exports["default"] = _default;